# -*- coding: utf-8 -*-
# @Time    : 2025/1/8 14:28
# @Author  : zhaoxiangpeng
# @File    : 20250108_func.py

import os
import pandas as pd
from pymongo import MongoClient

READ_PATH = 'Y:\\wos-metadata\\SCHOOL\\bnu'

DOI_SPLIT_SYMBOL = 'DOI '
DOI_SPLIT_SYMBOL_LENGTH = len(DOI_SPLIT_SYMBOL)
INFO_SPLIT_SYMBOL = ', '
INFO_SPLIT_SYMBOL_LENGTH = len(INFO_SPLIT_SYMBOL)

# 引文表需要有一个UT字段用来作为主键
REF_RECORD_TABLE_FIELD = ['UT', 'doi']
#  完整记录要保留的字段
FULL_RECORD_TABLE_FIELD = ['DI', 'SO', 'PT', 'UT', 'AB', 'SN', 'IS', 'EI', 'BN']


client = MongoClient(config.MONGODB_REMOTE_CONFIG.get("url"))


def find_doi_data_from_mongo():
    pass


def doi_match_full_record():
    """
    对引文的doi补充完整记录
    """
    doi_table = pd.DataFrame()
    full_record_table = pd.DataFrame()
    ref_table = doi_table.merge(right=full_record_table, how='left', left_on=['di'], right_on=['DI'])
    ref_table.to_csv(os.path.join(os.path.join('Y:\数据采集需求\陶思琪20211203', 'doi展开')), '%s.csv' % '', index=False)


def func1():
    """
    匹配查找没有下载到的wos号
    """
    os.listdir()


def verify_doi(text) -> str:
    doi_idx = text.find(DOI_SPLIT_SYMBOL)
    if doi_idx != -1:
        doi_str = text[doi_idx + DOI_SPLIT_SYMBOL_LENGTH:]
    else:
        doi_str = text
    if doi_str.endswith(')'):
        doi_str = doi_str[:-1]
    return doi_str


def ref_str2dic(text):
    ref_list = text.split('; ')
    for ref in ref_list:
        # print(ref)
        """
        """
        # 解析引文字段的信息
        ref_copy = ref
        var1 = []
        for _ in range(3):
            idx_t = ref_copy.find(INFO_SPLIT_SYMBOL)
            var1.append(ref_copy[:idx_t])
            ref_copy = ref_copy[idx_t + INFO_SPLIT_SYMBOL_LENGTH:]
        au, py, so = var1
        doi_idx = ref.find(DOI_SPLIT_SYMBOL)
        model = dict(au=au, py=py, so=so)
        if doi_idx != -1:
            doi_text = ref[doi_idx+DOI_SPLIT_SYMBOL_LENGTH:]
            if doi_text.startswith('['):
                doi_mutil_text = doi_text[1:-1]
                doi_list = doi_mutil_text.split(', ')
                for doi_str in doi_list:
                    if doi := verify_doi(doi_str):
                        obj = dict(doi=doi)
                        obj.update(**model)
                        yield obj
            else:
                if doi := verify_doi(doi_text):
                    obj = dict(doi=doi)
                    obj.update(**model)
                    yield obj
        else:
            obj = dict(doi=None)
            obj.update(**model)
            yield obj


def mian2():
    school_list = os.listdir(READ_PATH)
    for ff in school_list:
        if ff == 'doi展开' or ff == '待下载DOI':
            continue
        clear = []
        school_path = os.path.join(READ_PATH, ff)
        file_list = os.listdir(school_path)
        for file in file_list:
            f = os.path.join(school_path, file)
            table = pd.read_csv(f, sep='\t', error_bad_lines=False)
            table = table[['UT', "CR"]]
            values = table.values.tolist()
            for value in values:
                third_id, article_reference_text = value
                if pd.isna(article_reference_text):
                    continue
                _g = ref_str2dic(article_reference_text)
                for r_doi in _g:
                    r_doi.setdefault('third_id', third_id)
                    clear.append(r_doi)

        table2 = pd.DataFrame(clear)
        table2.to_csv(os.path.join(os.path.join('Y:\数据采集需求\陶思琪20211203', 'doi展开'), '%s.csv' % os.path.basename(school_path)),
                      index=False)


if __name__ == '__main__':
    """
    text1 = 'Baskonus HM, 2019, APPL MATH NONLIN SCI, V4, P129, DOI 10.2478/AMNS.2019.1.00013; Deng M, 2020, OPT EXPRESS, V28, P24152, DOI 10.1364/OE.395204; Kaur D, 2020, APPL MATH NONLIN SCI, V5, P15, DOI 10.2478/AMNS.2020.2.00011; Le LT, 2020, MARIT POLICY MANAG, V47, P615, DOI 10.1080/03088839.2020.1729437; Lin HR, 2021, IEEE T CIRCUITS-I, V68, P3397, DOI 10.1109/TCSI.2021.3081150; Ray A, 2020, NAT HAZARDS, V103, P3523, DOI 10.1007/s11069-020-04141-2; Shariati M., 2021, J. Adv. Eng. Comput., V5, P50, DOI 10.25073/jaec.202151.308; Sharifi Y, 2020, IJST-T CIV ENG, V44, P579, DOI 10.1007/s40996-019-00281-z; Yariyan P, 2022, GEOCARTO INT, V37, P4312, DOI 10.1080/10106049.2021.1892208; Zhao DW, 2020, J MATER RES TECHNOL, V9, P1231, DOI 10.1016/j.jmrt.2019.11.050'
    text2 = 'Booth W., 1979, CRITICAL UNDERSTANDI; Booth Wayne, 1988, THE COMPANY WE KEEP; Booth WC, 2005, COMPANION TO NARRATIVE THEORY, P75, DOI 10.1002/9780470996935.ch5; Booth Wayne C., 1983, THE RHETORIC OF FICT, P401; Booth Wayne C., 1961, THE RHETORIC OF FICT; Booth WayneC., 1994, UNDERSTANDING NARRAT, P99; Chatman Seymour, 1978, STORY AND DISCOURSE; Crane R. S., 1952, Critics and Criticism, P62; Emanuel JamesA., 1967, LANGSTON HUGHES; Herman D, 2008, PARTIAL ANSW, V6, P233, DOI 10.1353/pan.0.0019; Herman L, 2011, STYLE, V45, P11; Kindt T, 2011, STYLE, V45, P67; NELLES W, 1993, COMP LITERATURE, V45, P22, DOI 10.2307/1771304; Nunning Ansgar, 2005, THE ROUTLEGE ENCYCLO, P239; Nünning V, 2004, STYLE, V38, P236; Phelan J, 2011, STYLE, V45, P119; Phelan James, 1996, NARRATIVE RHETORIC T; Phelan James, 2005, LIVING TO TELL ABOUT; Phelan James., 2007, EXPERIENCING FICTION; RABINOWITZ PJ, 1977, CRIT INQUIRY, V4, P121, DOI 10.1086/447927; RABINOWITZ PJ, 1987, BEFORE READING NARRA; Rader Ralph W, 1978, U TORONTO Q, V48, P149; Rader RalphW., 1999, Ideology and Form in Eighteenth-Century Literature, P47; RADER RW, 1984, CRIT INQUIRY, V10, P567, DOI 10.1086/448264; Richardson B, 2011, STYLE, V45, P1; Ryan ML, 2011, STYLE, V45, P29; Shen D, 2007, J LITERARY SEMANTICS, V36, P53, DOI 10.1515/JLS.2007.003; Shen D, 2011, STYLE, V45, P576; Shen D, 2011, STYLE, V45, P80; Shen D, 2010, ENGL STUD, V91, P150, DOI 10.1080/00138380903355163; Shen D, 2008, NINETEEN CENT LIT, V63, P321, DOI 10.1525/ncl.2008.63.3.321; Shen Dan, THE LIVING HANDBOOK; Stefanescu M, 2011, STYLE, V45, P48; Tillotson Kathleen Mary., 1959, THE TALE AND THE TEL; Zerweck B, 2001, STYLE, V35, P151'
    text3 = '[Anonymous], POSTMODERNISM AM LIT; BARTH J, 1980, ATLANTIC, V245, P65; Bertens Hans., 1986, Approaching Postmodernism: Papers Presented at a Workshop on Postmodernism, 21-23 September 1984, University of Utrecht, P9; Calinescu Matei., 1987, EXPLORING POSTMODERN; Calinescu Matei., 1987, 5 FACES MODERNITY MO; Cohen Ralph., 1989, POSTMODERN GENRES, P11; Connor S., 1989, POSTMODERNIST CULTUR; FANG F, 1992, ZHONGPIANXIAOSHUO XU, V2, P93; FOKKEMA Douwe., 1986, Approaching Postmodernism; Fokkema DouweW., 1984, Literary History, Modernism, and Postmodernism; FORSTER H, 1983, ANTI-AESTHETIC ESSAY; Habermas J., 1981, NEW GER CRIT, P3; HABERMAS J, ANTI-AESTHETIC ESSAY; Hassan Ihab., 1975, PARACRITICISMS 7 SPE; Hassan IhabH., 1987, The Postmodern Turn: Essays in Postmodern Theory and Culture; Hutcheon Linda., 1988, POETICS POSTMODERNIS; Hutcheon Linda., 1989, Politics of Postmodernism; Hutcheon Linda., 1989, Postmodern Genres. Ed, P54; Jameson Frederic., 1991, POSTMODERNISM, DOI DOI 10.1215/9780822378419-002; Jameson Fredric., 1981, The Political Unconscious: Narrative as a Socially Symbolic Act; KOHLER M, 1977, AMERIKASTUDIEN, V22, P8; LIU Z, 1992, WENYI ZHENGMIN DEBAT, V1, P73; Lyotard Jean-Francois., POSTMODERN CONDITION; MCHALE B, 1990, STYLE, V24, P1; McHale Brian., 1992, CONSTRUCTING POSTMOD; McHale Brian., 1987, POSTMODERNIST FICTIO; Nemoianu Virgil., 1989, A Theory of the Secondary: Literature, Progress, and Reaction; Perloff Marjorie., 1989, POSTMODERN GENRES; PUTZ M, 1984, POSTMODERNISM AM LIT; Ross Andrew., 1986, FAILURE MODERNISM SY; WANG N, 1993, SOCIAL SCI CHINA, V19, P5; WANG N, INPRESS NEW LIT HIST; Wilde Alan., 1981, HORIZONS ASSENT MODE'
    text4 = "Abadi M, 2004, LECT NOTES COMPUT SC, V3142, P46; Abadi M, 2002, J CRYPTOL, V15, P103, DOI 10.1007/s00145-001-0014-7; Abadi M, 2001, ACM SIGPLAN NOTICES, V36, P104, DOI 10.1145/373243.360213; Abadi M., 1991, Proceedings of the Tenth Annual ACM Symposium on Principles of Distributed Computing, P201, DOI 10.1145/112600.112618; Accorsi R., 2001, LOGICAL ASPECTS CRYP, V55, P5, DOI [10.1016/S1571-0661(04)00242-7, DOI 10.1016/S1571-0661(04)00242-7]; Alur R, 1998, LECT NOTES COMPUT SC, V1427, P521, DOI 10.1007/BFb0028774; Alur R, 2007, LECT NOTES COMPUT SC, V4424, P664; Alur R, 2006, LECT NOTES COMPUT SC, V4052, P107; Anderson R, 1995, LECT NOTES COMPUT SC, V1000, P426; [Anonymous], 2004, INT C COMPUTER AIDED, DOI DOI 10.1007/978-3-540-27813-9_41; [Anonymous], 2009, J APPL NONCLASSICAL; Baltag A, 1999, Technical Report SEN-R9922; Baltag A, 2008, SYNTHESE, V165, P179, DOI 10.1007/s11229-008-9369-8; Baskar A., 2007, Proceedings of the 11th conference on Theoretical aspects of rationality and knowledge, P62; Bhargava M, 2005, LECT NOTES COMPUT SC, V3653, P171, DOI 10.1007/11539452_16; Bieber P., 1990, Proceedings. The Computer Security Foundations Workshop III (Cat. No.TH0315-2), P14, DOI 10.1109/CSFW.1990.128181; BROOKES SD, 1984, J ACM, V31, P560, DOI 10.1145/828.833; BURROWS M, 1990, ACM T COMPUT SYST, V8, P18, DOI [10.1145/77648.77649, 10.1145/74851.74852]; Chadha R, 2009, LECT NOTES COMPUT SC, V5522, P182, DOI 10.1007/978-3-642-02138-1_12; Chaum D., 1988, Proceedings of the Twentieth Annual ACM Symposium on Theory of Computing, P11, DOI 10.1145/62212.62214; Chaum D., 1988, Journal of Cryptology, V1, P65, DOI 10.1007/BF00206326; Ciobâca S, 2009, LECT NOTES ARTIF INT, V5663, P355, DOI 10.1007/978-3-642-02959-2_27; Clarke E. M., 1998, Programming Concepts and Methods. PROCOMET '98. IFIP TC2/WG2.2,2.3 International Conference, P87; Clarke EM, 1999, MODEL CHECKING, P1; COHEN M, 2005, P FCS 05, P121; Cohen M., 2005, METHODS MODALITIES, P202; Cohen M., 2009, P AAMAS, P945; Cohen M, 2007, IEEE S LOG, P77, DOI 10.1109/LICS.2007.4; Cohen M, 2009, 21ST INTERNATIONAL JOINT CONFERENCE ON ARTIFICIAL INTELLIGENCE (IJCAI-09), PROCEEDINGS, P721; Cremers C., 2006, Ph.D. dissertation; Dechesne F, 2008, LECT NOTES COMPUT SC, V5160, P111, DOI 10.1007/978-3-540-85762-4_8; Dechesne F, 2007, LECT NOTES ARTIF INT, V4790, P226, DOI 10.1007/978-3-540-75560-9_18; Delaune S, 2009, J COMPUT SECUR, V17, P435, DOI 10.3233/JCS-2009-0340; Delaune Stephanie., 2006, 19 IEEE COMPUTER SEC, P28; Dixon C., 2003, ULCS03022 U LIV DEP; DOLEV D, 1983, IEEE T INFORM THEORY, V29, P198, DOI 10.1109/TIT.1983.1056650; Durgin N., 1999, WORKSH FORM METH SEC; EMERSON EA, 1987, INFORM PROCESS LETT, V24, P77, DOI 10.1016/0020-0190(87)90097-4; Engelhardt K., 2002, ADV MODAL LOGIC, V9, P9; Engelhardt K, 2007, LECT NOTES COMPUT SC, V4514, P195, DOI 10.1007/978-3-540-72734-7_14; Fabrega F. J. T., 1999, Journal of Computer Security, V7, P191; Fagin R., 1995, Proceedings of the Fourteenth Annual ACM Symposium on Principles of Distributed Computing, P153, DOI 10.1145/224964.224982; Fagin R., 1995, Reasoning About Knowledge; Fischer MJ, 1996, J CRYPTOL, V9, P71, DOI 10.1007/s001459900004; Focardi R, 2004, LECT NOTES ARTIF INT, V2946, P139; Francien D., 2007, P WORKSH LOG RAT INT, P129; GARCIA F ERNANDEZ., 2005, Actas del XVI Congreso de ASELE, P63; Gerbrandy J., 1997, Journal of Logic, Language and Information, V6, P147, DOI 10.1023/A:1008222603071; Gong L., 1990, Proceedings. 1990 IEEE Computer Society Symposium on Research in Security and Privacy (Cat. No.90CH2884-5), P234, DOI 10.1109/RISP.1990.63854; Halpern J, 2002, P IEEE CSFW, P32, DOI 10.1109/CSFW.2002.1021805; Halpern J. Y., 1994, Theoretical Aspects of Reasoning About Knowledge. Proceedings of the Fifth Conference (TARK 1994), P255; Halpern J. Y., 2003, ACM Transactions on Information and Systems Security, V6, P43, DOI 10.1145/605434.605436; Halpern JY, 2005, J COMPUT SECUR, V13, P483; Halpern JY, 2011, ARTIF INTELL, V175, P220, DOI 10.1016/j.artint.2010.04.009; Halpern Joseph Y, 1991, Artificial Intelligence and Mathematical Theory of Computation. Papers in Honor of John McCarthy, V212, P151, DOI DOI 10.1016/B978-0-12-450010-5.50015-3; Halpern JosephY., 1986, Proceedings of the eighteenth annual ACM symposium on Theory of computing, P304; HALPERN JY, 1989, DISTRIB COMPUT, V3, P159, DOI 10.1007/BF01784885; Halpern JY, 2003, LECT NOTES COMPUT SC, V2629, P115; HALPERN JY, 1990, J ACM, V37, P549, DOI 10.1145/79147.79161; HINTIKKA J., 1962, Knowledge and Belief: An Introduction to the Logic of the Two Notions; Hommersom A, 2005, INFORMATION, INTERACTION, AND AGENCY, P289, DOI 10.1007/1-4020-4094-6_10; Hoshi T, 2009, SYNTHESE, V169, P259, DOI 10.1007/s11229-009-9552-6; Hunter A., 2007, Proceedings of the 22nd national conference on Artificial intelligence, V1, P427; Jonker HL, 2006, LECT NOTES COMPUT SC, V4176, P476; Jonker H. L., 2006, WORKSH TRUSTW EL 200; Kacprzak M, 2008, FUND INFORM, V85, P313; Kramer S., 2007, THESIS EPFL; LAUCHLI H, 1987, J SYMBOLIC LOGIC, V52, P219, DOI 10.2307/2273878; Lomuscio Alessio, 2007, SIGACT News, V38, P77, DOI 10.1145/1324215.1324231; Lomuscio A., 2006, 5 INT JOINT C AUT AG, P548; Lomuscio A, 2006, LECT NOTES COMPUT SC, V3920, P450; Lomuscio A, 2009, LECT NOTES COMPUT SC, V5643, P682, DOI 10.1007/978-3-642-02658-4_55; Lowe G., 1996, Tools and Algorithms for the Construction and Analysis of Systems. Second International Workshop, TACAS '96. Proceedings, P147; Meyden van der R., 2007, P 11 C THEOR ASP RAT, P212; NEEDHAM RM, 1978, COMMUN ACM, V21, P993, DOI 10.1145/359657.359659; Orzan S., 2005, LYS; Parikh R., 1985, Logics of Programs. Proceedings, P256; Parikh R., 2003, Journal of Logic, Language and Information, V12, P453, DOI 10.1023/A:1025007018583; Paulson L. C., 1998, Journal of Computer Security, V6, P85; Paulson LC, 1997, P IEEE CSFW, P70, DOI 10.1109/CSFW.1997.596788; Petride S., 2007, P 11 C THEORETICAL A, P239; Plaza J. A., 1989, P 4 INT S METH INT S, P201; Pucella R, 2006, J LOGIC COMPUT, V16, P287, DOI 10.1093/logcom/exi078; Ramanujam R, 2005, J COMPUT SECUR, V13, P135, DOI 10.3233/JCS-2005-13106; Ramanujam R., 2005, P TARK, P219; Reiter M. K., 1998, ACM T INFORM SYST SE, V1, P66, DOI DOI 10.1145/290163.290168; Ryan P.Y. A., 2001, MODELLING ANAL SECUR; Shilov Nikolay V., 2002, FICS, P25; Shmatikov V., 2004, Journal of Computer Security, V12, P355; Su K, 2004, PROCEEDING OF THE NINETEENTH NATIONAL CONFERENCE ON ARTIFICIAL INTELLIGENCE AND THE SIXTEENTH CONFERENCE ON INNOVATIVE APPLICATIONS OF ARTIFICIAL INTELLIGENCE, P98; SYVERSON P, 1992, J COMPUTER SECURITY, V1, P317; Syverson PF, 1999, LECT NOTES COMPUT SC, V1708, P814; Teepe W., 2006, P FAMAS 06, V6, P79; van Benthem J, 2006, INFORM COMPUT, V204, P1620, DOI 10.1016/j.ic.2006.04.006; van Benthem J, 2009, J PHILOS LOGIC, V38, P491, DOI 10.1007/s10992-008-9099-x; van Benthem Johan., 2007, P 11 C THEORETICAL A, P72; van der Hoek W., 2002, Proceedings of the First International Joint Conference on Autonomous Agents and Multiagent Systems, P1167; van der Meyden R, 2004, P IEEE CSFW, P280, DOI 10.1109/CSFW.2004.1310747; van der Meyden R., 1999, Foundations of Software Technology and Theoretical Computer Science. 19th Conference. Proceedings (Lecture Notes in Computer Science Vol.1738), P432; van Ditmarsch H., 2008, UNCONDITIONALLY SECU; van Ditmarsch HP, 2006, ELECTRON NOTES THEOR, V149, P105, DOI 10.1016/j.entcs.2005.07.029; van Ditmarsch H. P., 2003, Studia Logica, V75, P31, DOI 10.1023/A:1026168632319; van Eijck J., 2005, DEMO PROGRAM DOCUMEN; van Eijck J, 2007, ELECTRON NOTES THEOR, V168, P159, DOI 10.1016/j.entcs.2006.08.026; Von;;;;;;;;Wright GeorgH., 1951, ESSAY MODAL LOGIC; Wang Y., 2010, AAMAS 10 IN PRESS; WANG Y., 2009, Proceedings of the 12th Conference on Theoretical Aspects of Rationality and Knowledge, TARK'09 (California, 2009), P257"
    text5 = 'ADAMS F, 2003, BLACKWELL GUIDE PHIL, P143; [Anonymous], 2005, The Oxford Handbook of Philosophy of Mathematics and Logic; Baker A, 2005, MIND, V114, P223, DOI 10.1093/mind/fzi223; Benacerraf P., 1973, Journal of Philosophy, V70, P661, DOI DOI 10.2307/2025075; Chihara C., 2005, OXFORD HDB PHILOS MA; Colyvan M, 1999, PHILOS STUD, V96, P1, DOI 10.1023/A:1004248218844; Davidson D., 1980, ESSAYS ACTIONS EVENT; Field H, 1972, J PHILOS, V69, P347, DOI DOI 10.2307/2024879; Field H., 1989, Realism, mathematics and modality; Field Hartry, 1980, Science Without Numbers; HELLMAN G, 2005, OXFORD HDB PHILOS MA; HODES HT, 1984, J PHILOS, V81, P123, DOI 10.2307/2026440; Leng Mary., 2007, Mathematical Knowledge; Maddy P., 1997, NATURALISM MATH; Maddy P., 2007, Second philosophy: A naturalistic method; Neander K., 2004, STANFORD ENCY PHILOS; Papineau David., 2007, The Stanford Encyclopedia of Philosophy; Quine W.V., 1995, STIMULUS SCI; Quine W.V.O., 1992, PURSUIT TRUTH; Rosen G, 2005, OXFORD HDB PHILOS MA; SOBER E, 1993, PHILOS REV, V102, P35, DOI 10.2307/2185652; Stoljar D., 2010, PHYSICALISM; Wang H., 2007, LOGICAL JOURNEY GODE; Yalowitz S., 2005, Stanford Encyclopedia of Philosophy; Ye F., SYNTHESE IN PRESS; YE F, INTRO NATURALISTIC P; Ye F., PHILOS MATH IN PRESS; YE F, STRUCTURAL THEORY CO'

    g = ref_str2dic(text4)
    print([_ for _ in g])
    """
    mian2()
